Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr5.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr5.java	(revision 4810)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr5.java	(working copy)
@@ -18,6 +18,7 @@
 import java.util.HashMap;
 import java.util.List;
 import java.util.Map;
+import java.util.stream.Collectors;
 
 import uk.me.parabola.imgfmt.Utils;
 import uk.me.parabola.imgfmt.app.ImgFileWriter;
@@ -65,7 +66,7 @@
 		Sort sort = getConfig().getSort();
 		genCitiesAndMdr20s(sort);
 		// calculate positions for the different road indexes
-		calcMdr20SortPos(sort);
+		calcMdr20SortPos();
 		calcMdr21SortPos(sort);
 		calcMdr22SortPos(sort);
 	}
@@ -122,33 +123,17 @@
 	/**
 	 * Calculate a position when sorting by name, region, and country- This is used for MDR20. 
 	 */
-	private void calcMdr20SortPos(Sort sort) {
-		List<SortKey<Mdr5Record>> sortKeys = new ArrayList<>(allCities.size());
-		Map<String, byte[]> regionCache = new HashMap<>();
-		Map<String, byte[]> countryCache = new HashMap<>();
-		for (Mdr5Record m : allCities) {
-			if (m.getName() == null)
-				continue;
-
-			// Sort by city name, region name, and country name .
-			SortKey<Mdr5Record> sortKey = sort.createSortKey(m, m.getName());
-			SortKey<Mdr5Record> regionKey = sort.createSortKey(null, m.getRegionName(), 0, regionCache);
-			SortKey<Mdr5Record> countryKey = sort.createSortKey(null, m.getCountryName(), 0, countryCache);
-			sortKey = new MultiSortKey<>(sortKey, regionKey, countryKey);
-			sortKeys.add(sortKey);
-		}
-		regionCache = null;
-		countryCache = null;
-		sortKeys.sort(null);
-
-		SortKey<Mdr5Record> lastKey = null;
+	private void calcMdr20SortPos() {
+		List<Mdr5Record> sorted = allCities.stream()
+				.sorted((o1, o2) -> Integer.compare(o1.getMdr20Index(), o2.getMdr20Index()))
+				.collect(Collectors.toList());
 		int pos = 0;
-		for (SortKey<Mdr5Record> key : sortKeys) {
-			Mdr5Record c = key.getObject();
-			if (lastKey == null || key.compareTo(lastKey) != 0)
+		int lastKey = -1;
+		for (Mdr5Record c : sorted) {
+			if (c.getMdr20Index() != lastKey) 
 				pos++;
 			c.setMdr20SortPos(pos);
-			lastKey = key;
+			lastKey = c.getMdr20Index();
 		}
 	}
 
Index: src/uk/me/parabola/imgfmt/app/mdr/Mdr5Record.java
===================================================================
--- src/uk/me/parabola/imgfmt/app/mdr/Mdr5Record.java	(revision 4809)
+++ src/uk/me/parabola/imgfmt/app/mdr/Mdr5Record.java	(working copy)
@@ -125,6 +125,10 @@
 		this.mdr20Index = mdr20Index;
 	}
 
+	public int getMdr20Index() {
+		return mdr20Index;
+	}
+
 	public int getMdr20() {
 		return mdr20[mdr20Index];
 	}
